function varargout = GA_UI(varargin)
% GA_UI MATLAB code for GA_UI.fig
%      GA_UI, by itself, creates a new GA_UI or raises the existing
%      singleton*.
%
%      H = GA_UI returns the handle to a new GA_UI or the handle to
%      the existing singleton*.
%
%      GA_UI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GA_UI.M with the given input arguments.
%
%      GA_UI('Property','Value',...) creates a new GA_UI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GA_UI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GA_UI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GA_UI

% Last Modified by GUIDE v2.5 15-Jul-2014 21:35:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GA_UI_OpeningFcn, ...
                   'gui_OutputFcn',  @GA_UI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GA_UI is made visible.
function GA_UI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GA_UI (see VARARGIN)

% Choose default command line output for GA_UI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

initialize_gui(hObject, handles, false);
% UIWAIT makes GA_UI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GA_UI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in calculate.
function calculate_Callback(hObject, eventdata, handles)
% hObject    handle to calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%dispy(handles.metricdata.torque, handles.metricdata.diameter, handles.metricdata.length, handles.metricdata.vll, handles.metricdata.minpf, handles.metricdata.efficiency);
popup_sel_index = get(handles.dropdown, 'Value');
switch popup_sel_index
    case 1
        handles.metricdata.C = 1;
    case 2
        handles.metricdata.C = 2;
    case 3
        handles.metricdata.C = 3;
end

motor = Optimering_test(handles.metricdata.torque, handles.metricdata.diameter, handles.metricdata.length, handles.metricdata.vll, handles.metricdata.minpf, handles.metricdata.efficiency, handles.metricdata.C);

mass = round(motor.mech.M_weight);
costs = round(motor.cost.mech);
cdouter = motor.variables.C_DO*1000;
cdepth = motor.variables.C_d*1000;
poles = motor.variables.Np;
current = motor.variables.J;
alfam = motor.variables.alpha_m;
airgap = motor.variables.g*1000;
mdepth = motor.variables.M_d*1000;
nlay = motor.variables.N_lay;
effi = motor.el.efficiency*1000/10;
pfac = round(motor.el.cos_phi*100)/100;
machines = motor.geom.M;
alength = round(motor.mech.M_totL*1000);

set(handles.mass, 'String', mass);
set(handles.costs, 'String', costs);
set(handles.cdouter, 'String', cdouter);
set(handles.poles, 'String', poles);
set(handles.current, 'String', current);
set(handles.mdepth, 'String', mdepth);
set(handles.airgap, 'String', airgap);
set(handles.alfam, 'String', alfam);
set(handles.cdepth, 'String', cdepth);
set(handles.alength, 'String', alength);
set(handles.nlay, 'String', nlay);
set(handles.effi, 'String', effi);
set(handles.pfac, 'String', pfac);
set(handles.machines, 'String', machines);

% --- Executes on selection change in dropdown.
function dropdown_Callback(hObject, eventdata, handles)
% hObject    handle to dropdown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns dropdown contents as cell array
%        contents{get(hObject,'Value')} returns selected item from dropdown


% --- Executes during object creation, after setting all properties.
function dropdown_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dropdown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject, 'String', {'Machine Cost', 'Total Lifetime Cost', 'Machine Weight'});


function torque_Callback(hObject, eventdata, handles)
% hObject    handle to torque (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of torque as text
%        str2double(get(hObject,'String')) returns contents of torque as a double
torque = str2double(get(hObject, 'String'));
if isnan(torque)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.torque = torque;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function torque_CreateFcn(hObject, eventdata, handles)
% hObject    handle to torque (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function diameter_Callback(hObject, eventdata, handles)
% hObject    handle to diameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of diameter as text
%        str2double(get(hObject,'String')) returns contents of diameter as a double
diameter = str2double(get(hObject, 'String'));
if isnan(diameter)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.diameter = diameter;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function diameter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to diameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function length_Callback(hObject, eventdata, handles)
% hObject    handle to length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of length as text
%        str2double(get(hObject,'String')) returns contents of length as a double
length = str2double(get(hObject, 'String'));
if isnan(length)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.length = length;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function length_CreateFcn(hObject, eventdata, handles)
% hObject    handle to length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function vll_Callback(hObject, eventdata, handles)
% hObject    handle to vll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of vll as text
%        str2double(get(hObject,'String')) returns contents of vll as a double
vll = str2double(get(hObject, 'String'));
if isnan(vll)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.vll = vll;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function vll_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function minpf_Callback(hObject, eventdata, handles)
% hObject    handle to minpf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of minpf as text
%        str2double(get(hObject,'String')) returns contents of minpf as a double
minpf = str2double(get(hObject, 'String'));
if isnan(minpf)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.minpf = minpf;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function minpf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to minpf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function efficiency_Callback(hObject, eventdata, handles)
% hObject    handle to efficiency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of efficiency as text
%        str2double(get(hObject,'String')) returns contents of efficiency as a double
efficiency = str2double(get(hObject, 'String'));
if isnan(efficiency)
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

% Save the new density value
handles.metricdata.efficiency = efficiency;
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function efficiency_CreateFcn(hObject, eventdata, handles)
% hObject    handle to efficiency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function initialize_gui(fig_handle, handles, isreset)
% If the metricdata field is present and the reset flag is false, it means
% we are we are just re-initializing a GUI by calling it from the cmd line
% while it is up. So, bail out as we dont want to reset the data.
if isfield(handles, 'metricdata') && ~isreset
    return;
end

handles.metricdata.torque = 0;
handles.metricdata.diameter  = 0;
handles.metricdata.length = 0;
handles.metricdata.vll  = 0;
handles.metricdata.minpf = 0;
handles.metricdata.efficiency  = 0;

set(handles.torque, 'String', handles.metricdata.torque);
set(handles.diameter,  'String', handles.metricdata.diameter);
set(handles.length, 'String', handles.metricdata.length);
set(handles.vll,  'String', handles.metricdata.vll);
set(handles.minpf, 'String', handles.metricdata.minpf);
set(handles.efficiency,  'String', handles.metricdata.efficiency);

guidata(handles.figure1, handles);
